#include <sys/types.h>
#include <unistd.h>

/* setup the uid & gid */
/* code take from proftpd */
/* code coyright by the proftpd team */
#  define PRIVS_SETUP(u, g) { \
    if (getuid() != ROOT_UID) { \
      daemon_uid = getuid(); \
      daemon_gid = getgid(); \
      if (setgid(daemon_gid)) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to setgid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
      if (setuid(daemon_uid)) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to setuid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
      if (seteuid(daemon_uid)) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to seteuid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
    } else { \
      daemon_uid = (u); \
      daemon_gid = (g); \
      if (setuid(ROOT_UID)) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to setuid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
      if (setgid((g))) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to setgid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
      if (seteuid((u))) { \
        print_log(LOG_ERR, "PRIVS_SETUP: unable to seteuid(): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
    } \
  }

/* Switch back to root privs. */
/* code take from proftpd */
/* code coyright by the proftpd team */
#  define PRIVS_ROOT { \
    if (seteuid(ROOT_UID)) { \
      print_log(LOG_ERR, "PRIVS_ROOT: unable to seteuid(): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
    if (setegid(ROOT_UID)) { \
      print_log(LOG_ERR, "PRIVS_ROOT: unable to setegid(): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
  }

/* Relinquish privs granted by PRIVS_ROOT or PRIVS_USER.  */
/* code take from proftpd */
/* code coyright by the proftpd team */
#  define PRIVS_RELINQUISH { \
    if (geteuid() != ROOT_UID) { \
      if (seteuid(ROOT_UID)) { \
        print_log(LOG_ERR, "PRIVS_RELINQUISH: unable to seteuid(ROOT_UID): %s", \
          strerror(errno)); \
	safe_exit(-1); \
      } \
    } \
    if (setegid(daemon_gid)) { \
      print_log(LOG_ERR, "PRIVS_RELINQUISH: unable to setegid(daemon_gid): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
    if (seteuid(daemon_uid)) { \
      print_log(LOG_ERR, "PRIVS_RELINQUISH: unable to seteuid(daemon_uid): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
  }

/* Revoke all privs. */
/* code take from proftpd */
/* code coyright by the proftpd team */
#  define PRIVS_REVOKE { \
    if (seteuid(ROOT_UID)) { \
      print_log(LOG_ERR, "PRIVS_REVOKE: unable to seteuid(): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
    if (setgid(daemon_gid)) { \
      print_log(LOG_ERR, "PRIVS_REVOKE: unable to setgid(): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
    if (setuid(daemon_uid)) { \
      print_log(LOG_ERR, "PRIVS_REVOKE: unable to setuid(): %s", \
        strerror(errno)); \
	safe_exit(-1); \
      } \
  }
